* '
* ' Modi.prg - Modify dBFast Files.  New Version
* '
* ' Skip Morehead - Copyright 1990
* '

set window title to ' Create/Modify Data Files '

set procedure to modi
set procedure to proclib

set eventmsk to 159
set safety off
set talk off
set bell off
set deleted on

home_dir = currentdir()


operation = a_none

create popup menu 'File' from;
    'New...;' + ;
    'Open...;' + ;
    'Close;' + ;
    ';' + ;
    'Exit' at 1,1

* '
* ' The '...' on the menu options above is a clue to the user
* ' that additional dialog will appear when the option is selected
* '

create popup menu '\aHelp' from 'About Modi' at 3,1

create pulldown menu 'modi' from 'File', '\aHelp'
set menu to 'modi'

* '
* ' The \a on the Help menu above tells dBFast to put that menu
* ' to the extreme right of the window
* '

disable menu 1,3            && Close

* '
* ' Disable this option because there is no active file,
* ' can't close something that is not open!
* '

mscreensz = 15
mdisplines = mscreensz - 1
mthumb = 1.00
store 0 to row, mold_row, action
store 1 to mcount, mcurr_rec, mplace, mtoprec
store .f. to adding, inserting, changed, mnew, mfile
mredraw = .t.
mdbfname = space(8)
readagain = .t.

temp_file1 = tempfile(1,'.DBF')

select a

select window 'CONSOLE'

set window type to 65
********************************************************
*Lowered window by 1 to center it with other screen objects
create window ' Fields ' from 3,5 to 19,40
@ 0,0 say '  #  Field Name  Type  Len  Dec'
select window 'CONSOLE'

do draw_form

do_action(a_open)
if empty(mdbfname)
    do_action(a_new)
endif
    
do while .t.
    select window 0
    
    do disp_op
    
    if .not. empty(mdbfname)
        if reccount() > 0
            msfactor = reccount() - mdisplines
            if msfactor = 0
                inc msfactor
            endif
            msfactor = 1000 / msfactor
            do display_fields
*            go mtoprec + mplace - 1
        else
            disable button b_insert
            disable button b_delete
        endif
        
        if readagain
          @ 8,55 get field_name picture '!!!!!!!!!!' ;
            valid chk_name(field_name) error "Duplicate or Invalid Field Name"
          @ 10,55 get field_len picture '###' ;      
            valid chk_len(field_len,field_type) error 'Max Field Length is 250 or 16 for Numeric' ;
            when field_type $ 'CN'
          @ 12,55 get field_dec picture '##' ;
            valid chk_dec(field_dec,field_type) CHANGE error 'Maximum Decimals is 15' ;
            when field_type = 'N'
          @ 11,60 get field_type radiobutton ;
             'Character;Numeric;Date;Logical;Memo;Picture' ;
             valid chkFType(field_type)
          readagain = .f.
        else
           update gets
        endif
        read save
        if updated()
          changed = .t.
        endif
    else
        wait ""
    endif
    action = get_action()
    if action = 0
      loop
    endif
    if do_action(action)
        loop
    endif

    if action = a_done
        chdir(home_dir)
        return
    endif


    if adding .and. action = a_ok
        do_action(a_add)
        loop
    endif

    if inserting .and. action = a_ok
        do_action(a_insert)
        loop
    endif
    
    if .not. empty(mdbfname) .and. reccount() < 128 .and. recno() <> reccount()
        skip
        inc mplace
    endif
enddo

*
*       Functions and Procedures
*

function get_action
* '
* ' This function gets the event that terminated the READ
* ' and translates it into an internal action.
* '
* ' The biggest advantage of this style of event handling is
* ' that it allows you to map events from different sources
* ' to the same action, e.g., both the ADD button and CTRL-A
* ' return A_ADD (action add)
* '
* ' All of the ?_event variables are defined in MODI.INC
* '

    the_event = event()
    do case
        case the_event = b_event
            the_button = button()
            do case
                case the_button = b_ok
                    return a_ok
                case the_button = b_cancel
                    return a_cancel
                case the_button = b_add
                    return a_add
                case the_button = b_insert
                    return a_insert
                case the_button = b_delete
                    return a_delete
            endcase
        case the_event = c_event
            return a_done
        case the_event = k_event
            the_key = lastkey()
            if adding .or. inserting
              if the_key = 27
                 return a_cancel
              endif
              return the_key
            endif
            do case
                case the_key = 1        && Ctrl-A
                    return a_add
                case the_key = 3        && Ctrl-C
                    return a_cancel
                case the_key = 4        && Ctrl-D
                    return a_delete
                case the_key = 9        && Ctrl-I
                    return a_insert
                case the_key = 15       && Ctrl-O
                    return a_ok
                case the_key = 27
                    return a_done
                case the_key = 530      && PgUp
                     do scroll_win with 0,1,0
                     return(0)
                case the_key = 536    
                     do scroll_win with 0,2,0
                     return(0)
                case the_key = 539       && Home
                     if mtoprec > 1
                       mredraw = .t.
                     endif
                     mtoprec = 1
                     mplace = 1
                     return(0)
                case the_key = 545
                     mtoprec = reccount() - mdisplines
                     if mtoprec < 1
                        mtoprec = 1
                        mplace = reccount()
                     else
                       mplace = mscreensz
                       mredraw = .t.
                     endif
                     return(0)
               otherwise
                    return lastkey()
            endcase
        case the_event = l_event
            return l_event
        case the_event = m_event
            the_hmenu = hmenu()
            the_vmenu = vmenu()
            do case
                case the_hmenu = m_file
                    do case
                        case the_vmenu = 1
                            return a_new
                        case the_vmenu = 2
                            return a_open
                        case the_vmenu = 3
                            return a_close
                        case the_vmenu = 5
*                            return a_save
*                        case the_vmenu = 7
                            return a_done
                    endcase
                case the_hmenu = m_help
                    return a_help
            endcase
        case the_event = w_event
            return w_event
        otherwise
            ?? chr(7)
            return 0
    endcase
    
    return 0
    

function do_action
    parameter the_action

    do case
        case the_action = a_new
            mdbfname = space(8)
            create window ' New Data File ' 5,19 to 10,61
            erase
            create button b_ok at 1,30
            create button b_cancel1 at 3,30
            @ 2,2 say 'New File Name:' ;
                    get mdbfname picture '!!!!!!!!!!' ;
                    valid valid_file(mdbfname) 
            read save
            do while event() <> b_event
                read save
            enddo
            clear gets
            readagain = .t.
            close window ' New Data File '
            select window 0
            if .not. empty(mdbfname) .and. button() <> b_cancel1
                if .not. '.' $ mdbfname
                    mdbfname = trim(mdbfname) + '.DBF'
                endif    
                if file(mdbfname)
                    warning(' File Exists ','File Already Exists',3)
                    operation = a_none
                    mdbfname = space(8)
                    return .t.
                endif
                if file(temp_file1)
                    erase &temp_file1
                endif
                select a
                copy to &temp_file1 structure extended
                use &temp_file1
                set window title to ' New Data File: ' + alltrim(mdbfname) + ' '
                enable button b_add
                disable menu 1,1
                disable menu 1,2
                enable menu 1,3
                mnew = .t.
                do_action(a_add)
            else
                mdbfname = space(8)
                operation = a_none
            endif
            return .t.
        case the_action = a_open
            mdbfname = dbfmenu()
            mtoprec = 1
            if .not. empty(mdbfname)
                if file(temp_file1)
                    erase &temp_file1
                endif
                select a
                use &mdbfname
                copy to &temp_file1 structure extended
                use &temp_file1
                select window 0
                set window title to ' Edit Data File: ' + ;
                                    alltrim(upper(mdbfname)) + ' '
                enable button b_add
                enable button b_insert
                enable button b_delete
                disable menu 1,1
                disable menu 1,2
                enable menu 1,3
                mredraw = .t.
                operation = a_editing
            else
                operation = a_none
            endif
            return .t.
        case the_action = a_close
            do closeup
            return .t.
*        case the_action = a_save
*            do save_it
*            return .t.
        case the_action = a_done
            clear gets
            readagain = .t.
            if .not. empty(mdbfname)
              if .not. CheckField()
                 delete
                 pack
              endif
              if changed .and. reccount() > 0
                if confirm('Save Changes?')
                    do save_it
                endif
              endif
            endif
            changed = .f.
            close window ' Fields '
            close menu 'modi'
            erase
            close all
            if file(temp_file1)
                erase &temp_file1
            endif
            return .f.
        case the_action = a_ok
            if adding .or. inserting
                return .f.
            endif
            return .t.
        case the_action = a_cancel
            clear gets
            readagain = .t.
            delete
            pack
            if adding
                go bottom
                if mtoprec > 1
                   dec mtoprec
                else
                  dec mplace
                endif
                if eof()
                   do closeup
                   return .t.
                endif
            endif
            adding = .f.
            inserting = .f.
            disable button b_cancel
            enable button b_add
            enable button b_insert
            enable button b_delete
            operation = a_editing
            mredraw = .t.
            return .t.    
        case the_action = a_add
            if reccount() = 128
                warning('Too Many Fields','There Are 128 Fields In This File',3)
            else
                append blank
                commit
                adding = .t.
                operation = a_add
                disable button b_add
                disable button b_insert
                disable button b_delete
                enable button b_cancel
                if reccount() > mscreensz
                    mtoprec = reccount() - mdisplines
                    mplace = mscreensz
                    mredraw = .t.
                else                    
                    mtoprec = 1
                    mplace = reccount()
                endif
            endif
            return .t.
        case the_action = a_insert
            if reccount() = 128
                warning('Too Many Fields','There Are 128 Fields In This File',3)
            else
                insert blank before
                inserting = .t.
                operation = a_insert
                disable button b_insert
                disable button b_add
                disable button b_delete
                enable button b_cancel
                mredraw = .t.
            endif
            return .t.
        case the_action = a_delete
            clear gets
            readagain = .t.
            if confirm('Really Delete This Field?')
               IF RECCOUNT() > 1
                delete
                pack
                changed = .t.
                mredraw = .t.
                if reccount() < 1
                   do closeup
                   return .t.
                endif
                if mtoprec > 1
                  dec mtoprec
                else
                  if mplace >= 1
                    dec mplace
                  endif
                endif
               ELSE
                  RETURN(.t.)
               ENDIF
             endif
            return .t.
        case the_action = l_event
            return .t.
        case the_action = w_event
            if empty(mdbfname)
                return .t.
            endif
            if window() <> ' Fields '
              beep
              return .t.
            endif
            if adding .or. inserting
              warning('Illegal Action in Add/Insert',;
              'No Movement Allowed',3)
              do while chkevent() <> -1
              enddo
              return(.T.)
            endif
            do while .t.
                mevent = chkevent()
                if mevent = -1
                    exit
                endif
                do case
                    case mevent = k_event
                    case mevent = w_event
                    case mevent = s_event
                        do scroll
                    case mevent = l_event
                        do click
                endcase
            enddo
            return .t.
        case the_action = a_help
            create window ' About ' from 5,15 to 16,65
            set window title to ' About Modify Data Files '
            erase
            create button b_ok at 10,20
            @ 1,0 say center('dBFast Modify Data Files',50)
            @ 3,0 say center('Version 0.02',50)
            @ 5,0 say center('Author: Skip Morehead',50)
            @ 7,0 say center('Special Keys are PgUp, PgDn, ^Home, ^End',50)
            wait ""
            close window ' About '
        otherwise
            return .t.
    endcase

    return .t.

procedure closeup
  clear gets
  readagain = .t.
  if .not. empty(mdbfname)
    if .not. CheckField()
      delete
      pack
    endif
    if changed .and. reccount() > 0
      if confirm('Save Changes?')
         do save_it
      endif
    endif
  endif
  changed = .f.
  select a
  use
  if file(temp_file1)
    erase &temp_file1
  endif
  mdbfname = space(8)
  enable menu 1,1
  enable menu 1,2
  disable menu 1,3
  select window 0
  mtoprec = 1
  mplace = 1
  do draw_form
  do display_fields
  set window title to ' Create/Modify Data Files '
  operation = a_none
  return


function chk_name
    parameter fld_name

   
    if empty(fld_name)
        return .t.
    endif

    fld_name = alltrim(fld_name)
    if reccount() > 0
        *
        * check for duplicate field names
        *
        found = .f.
        msave_rec = recno()
        go top
        locate for alltrim(upper(field_name)) = alltrim(upper(fld_name))
        if .not. eof() .and. recno() <> msave_rec
            go msave_rec
            return .f.
        endif
        go msave_rec
    endif        

    if ',' $ fld_name .or. ';' $ fld_name .or. '"' $ fld_name .or. ;
            "'" $ fld_name .or. '/' $ fld_name .or. '.' $ fld_name .or. ;
            '>' $ fld_name .or. '<' $ fld_name .or. '-' $ fld_name .or. ;
            ' ' $ fld_name
        return .f.
    else
        return .t.
    endif



procedure display_fields

    if action = w_event .and. (adding .or. inserting)
      mredraw = .f.
      return
    endif

    select window 1

    if .not. empty(mdbfname)
        if mredraw
            go mtoprec
            row = 0
            do while .not. eof()
                if row > mdisplines
                    exit
                endif
                msay_video = sayvideo()
                if recno() = mtoprec + (mplace - 1)
                    set say video to getvideo()
                    mold_row = row
                endif
                @ row + 1,0 say space(34)
                @ row + 1,0 say str(recno(),3,0)
                @ row + 1,5 say field_name picture '!!!!!!!!!!'
                @ row + 1,19 say field_type picture '!'
                @ row + 1,23 say field_len picture '999'
                @ row + 1,29 say field_dec picture '99'
                set say video to msay_video
                inc row
                skip
            enddo
            for counter = row to mdisplines
                @ row + 1,0 say space(34)
            next
            IF mtoprec + (mplace -1) = 0
               GO TOP
            ELSE   
               go mtoprec + (mplace - 1)
            ENDIF
            do MySetScroll
        else
            go mtoprec + mold_row
            row = mold_row
            @ row + 1,0 say space(34)
            @ row + 1,0 say str(recno(),3,0)
            @ row + 1,5 say field_name picture '!!!!!!!!!!'
            @ row + 1,19 say field_type picture '!'
            @ row + 1,23 say field_len picture '999'
            @ row + 1,29 say field_dec picture '99'
                 
            IF mtoprec + (mplace -1) = 0
               GO TOP
            ELSE
               go mtoprec + (mplace - 1)
            ENDIF   
            row = recno() - mtoprec
            mold_row = row
            msay_video = sayvideo()
            set say video to getvideo()
            @ row + 1,0 say space(34)
            @ row + 1,0 say str(recno(),3,0)
            @ row + 1,5 say field_name picture '!!!!!!!!!!'
            @ row + 1,19 say field_type picture '!'
            @ row + 1,23 say field_len picture '999'
            @ row + 1,29 say field_dec picture '99'
            set say video to msay_video
        endif
    else
        @ 1,0 clear to 15,40
        mold_row = 0
    endif

    select window 0
    mredraw = .f.

    return
    

procedure draw_form

    select window 0
    erase
    clear gets

    readagain = .t.
    @ 6,43 to 18,74
    @ 6,45 say 'Field'
    @ 10,59 to 17,72
    @ 10,61 say 'Type'

    @  8,45 say 'Name    :'
    @ 10,45 say 'Length  :'
    @ 12,45 say 'Decimals:'

    create button b_cancel at 4,50
    
    create button b_add at 20,42
    create button b_insert at 20,54
    create button b_delete at 20,67

    disable button b_add
    disable button b_insert
    disable button b_delete
    
    disable button b_cancel

    return


procedure save_it
    clear gets
    readagain = .t.
    if reccount() = 0
       return
    endif
    temp_file2 = tempfile(2,'.DBF')
    create &temp_file2 from &temp_file1

    if .not. mnew
        select a
        use &mdbfname
        select b
        use &temp_file2
        append from &mdbfname
        erase &temp_file1
        select a
        use
        rename &mdbfname to &temp_file1
        erase &mdbfname
    endif
    
    close databases

    rename &temp_file2 to &mdbfname
    if file(temp_file1)
        erase &temp_file1
    endif
    
*    if file(mdbfname + '.DBT')
*        erase &mdbfname..DBT
*    endif
*    if file(temp_file2 + '.DBT')
*        rename &temp_file2..DBT to &mdbfname..DBT
*    endif

    changed = .f.
    return


function tempfile
parameters file_num, file_ext
private temp_name
    
    temp_name = 'T' + substr(time(),1,2) + substr(time(),4,2) + ;
                substr(time(),7,2) + str(file_num,1,0)

    return(temp_name + file_ext)
    

function valid_file
    parameters fn

    fn = alltrim(fn)

    if ',' $ fn .OR. ';' $ fn .OR. '"' $ fn .OR. "'" $ fn .OR. ;
            '/' $ fn .OR. '>' $ fn .OR. '<' $ fn .or. '-' $ fn
        return(.f.)
    else
        return(.t.)
    endif

********************Changed These*****************************
function chk_len
    parameters fld_len, fld_type

    maxlen = 0
    do case
        case fld_type = 'C'
          maxlen = 250
        case fld_type = 'D'
          mexlen = 8
        case fld_type = 'L'
          maxlen = 1
        case fld_type = 'M'
          maxlen = 10
        case fld_type = 'N'
          maxlen = 16
        case fld_type = 'P'
          maxlen = 10
    endcase

    if maxlen > 0 .and. (fld_len > maxlen .or. fld_len < 1)
        return .f.
    else
        return .t.
    endif


function chk_dec
    parameters fld_dec, fld_type

    maxlen = 0
    do case
        case fld_type = 'N'
           maxlen = 15
    endcase

    if  fld_dec > maxlen
        return .f.
    else
        return .t.
    endif




**************************Added This *****************************
function chkFType
parameter type

    newlen = 0
    newdec = 0
    do case
        case field_type = 'C'
          newlen = 25
        case field_type = 'N'
          newlen = 12
          newdec = 2
        case field_type = 'D'
          newlen = 8
        case field_type = 'L'
          newlen = 1
        case field_type = 'M' .or. field_type = 'P'
          newlen = 10
    endcase

    
    if newlen > 0 .and. newlen <> field_len
 *     changed = .t.
      replace gets field_len with newlen
      if newdec <> field_dec
        replace gets field_dec with newdec
      endif
    endif
    return(.T.)
    
procedure disp_op
  @ 0,0
  do case
    case operation = a_add
      @ 0,0 say center('Adding New Fields',78)
    case operation = a_insert
      @ 0,0 say center('Inserting New Fields',78)
    case operation = a_editing
      @ 0,0 say center('Editing this Field',78)
    otherwise
      @ 0,0 say center('No Operation - Make a Menu Choice',78)
  endcase
  return
  
function CheckField
if (empty(a->field_name) .or. a->field_len < 1) .AND. RECCOUNT() > 1
  return(.F.)
endif
return(.T.)
  

